package jeliot.lang;

import java.lang.reflect.*;
import java.util.*;
import jeliot.parser.error.*;
import jeliot.FeatureNotImplementedException;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created         2.10.1999
  */
public class ArrayInstance extends Instance {

    private VariableInArray[] array;

    public ArrayInstance(ArrayType type, int length) {
        super(type);
        this.array = new VariableInArray[length];
        Type componentType = type.getComponentType();
        for (int i = 0; i < length; ++i) {
            array[i] = new VariableInArray(this);
            array[i].assign(componentType.neutralValue());
        }
    }
    
    public VariableInArray getVariableAt(int index) {
        return array[index];
    }
    
    public void setValueAt(int index, Value newValue) {
        array[index].assign(newValue);
    }
    
    public int length() {
        return array.length;
    }
        
}

   
    