package jeliot.lang;

import jeliot.parser.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created 28.9.1999
  */
public abstract class FieldPointer {

    /** Returns the type of this field.
      */
    public abstract Type getType();
    
    /** Returns the type of this field.
      */
    public abstract Type getDeclaringClass();
    
    /** Returns true if this field is declared as static.
      */
    public abstract boolean isStatic();
    
    /** Returns true if this is a private field.
      */
    public abstract boolean isPrivate();
    
    /** Returns the return value of the field.
      */
    public abstract Variable access(Director dir);
    
}
