package jeliot.lang;

import jeliot.parser.*;
import jeliot.theatre.*;

/**
  * @author Pekka Uronen
  *
  * created 29.9.1999
  */
public class LocalFieldPointer extends FieldPointer {

    PVariableDeclarator declarator;

    public LocalFieldPointer(PVariableDeclarator declarator) {
        this.declarator = declarator;
    }
    
    /** Returns the type of this field.
      */
    public Type getType() {
        return declarator.getType();
    }
    
    public Type getDeclaringClass() {
        return null;
    }
    
    /** Returns true if this field is declared as static.
      */
    public boolean isStatic() {
        return false;
    }
    
    /** Returns true if this is a private field.
      */
    public boolean isPrivate() {
        return true;
    }
    
    /** Returns the variable
      */
    public Variable access(Director dir) {
        MethodFrame mf = dir.getCurrentMethodFrame();
        return mf.getVariable(declarator);
    }
    
}
