package jeliot.lang;

import java.util.*;
import jeliot.parser.*;

/**
  * @author Pekka Uronen
  *
  * created         27.9.1999
  */
public class NullType extends ReferenceType {
    
    public static NullType nullTYPE = new NullType();
    
    private NullType() { }
    
    /** Checks if a value of this type may be assigned to a variable of
      * given type t.
      */
    public boolean mayBeAssignedTo(Type t) {
        return t instanceof ReferenceType;    
    }
    
    /** Checks if a value of this type can be cast to a value of type
      * t in an explicit cast. If 
      */
    public boolean mayBeCastTo(Type t) {
        return t instanceof ReferenceType;
    }
    
    public MethodPointer getMethod(String name, Type[] argt) {
        return null;
    }
    
    public FieldPointer getField(String name) {
        return null;
    }
    
    public String toString() {
        return "-null-";
    }
    
    
}