package jeliot.parser;

import java.util.*;

import jeliot.lang.*;
import jeliot.theatre.*;

/**
  * PExpression represents a single expression.
  *
  * @author Pekka Uronen
  *
  * created         5.8.1999
  */
public abstract class PExpression extends PElement {

    /** Number of pairs of parenthesis around this expression */
    private int parenthesis;

    /** Type of the value or variable of the result of evaluating
      * this expression */
    private Type valueType;

    protected PExpression() { } 

    protected PExpression(int left, int right) {
        super(left, right);
    }

    public boolean isPrimary() {
        return false;
    }

    public boolean usesScratch() {
        return true;
    }

    public abstract void acceptVisitor(ProgramTreeVisitor visitor);

    public void incParenthesis() {
        ++parenthesis;
    }
    
    public void setType(Type type) {
        this.valueType = type;
    }

    public Type getType() {
        return valueType;
    }

    public Value evaluate(Director director) {
        return null;
    }
    
    public Variable evaluateVariable(Director director) {
        return null;
    }

    public String toString() {
        return ( (valueType == null) ?
                "<null>" :
                getType().toString() )
                    +
                " "
                    +
                getClass().getName();
    }
            
    
}
