package jeliot.parser;


/**
  * PImport encapsualtes an import declaration in a compilation unit.
  *
  * @author Pekka Uronen
  *
  * created         5.8.1999
  */
public class PImport{

    protected PName name;
    protected boolean onDemand;
    protected int right;

    public PImport(PName name, boolean onDemand, int right) {
        this.name = name;
        this.onDemand = onDemand;
        this.right = right;
    }

    public String toString() {
        return "import " + name.toString() + (onDemand ? ".*;" : ";");
    }

    public PName getName() {
        return name;
    }

    public boolean isOnDemand() {
        return onDemand;
    }

    public String getPackageName() {
        if (onDemand) {
            return name.toString();
        }
        else {
            String s = name.toString();
            return s.substring(0, s.lastIndexOf('.'));
        }
    }

    public String getClassName() {
        if (onDemand) {
            return null;
        }
        else {
            String s = name.toString();
            return s.substring(s.lastIndexOf('.')+1);
        }
    }       
    
    
}
