package jeliot.parser;

/**
  * @author Pekka Uronen
  *
  * last modified   18.8.1999
  */
public class ProgramTreeVisitor {

    public void visitCompilationUnit(PCompilationUnit cu) { }
    public void visitClass(PClass c) { }
    public void leaveClass(PClass c) { }
    public void visitMethod(PMethod m) { }
    public void leaveMethod(PMethod m) { }
    
    public void visitStatement(PStatement s) { }
    
    public void enterBlock(PBlock b) {
        visitStatement(b);
    }
    public void leaveBlock(PBlock b) { }

    public void enterWhile(PWhile w) {
        visitStatement(w);
    }
    
    public void leaveWhile(PWhile w) { }
    
    public void enterFor(PFor f) {
        visitStatement(f);
    }
    
    public void leaveFor(PFor f) { }

    public void enterDoWhile(PDoWhile w) {
        visitStatement(w);
    }
    
    public void leaveDoWhile(PDoWhile w) { }
    
    public void visitIf(PIfThenElse ite) {
        visitStatement(ite);
    }
    
    public void visitThen(PIfThenElse ite) { }
    public void visitElse(PIfThenElse ite) { }
    public void visitExpressionStatement(PExpressionStatement s) {   
        visitStatement(s);
    }
    
    public void visitVariableDeclaration(PVariableDeclaration l) {
        visitStatement(l);
    }
    
    public void enterVariableDeclarator(PVariableDeclarator l) { }
    
    public void leaveVariableDeclarator(PVariableDeclarator l) { 
         }

    public void enterAssignmentExpression(PAssignmentExpr e) {
        enterExpression(e);
    }
    
    public void leaveAssignmentExpression(PAssignmentExpr e) { }
    
    public void enterBinaryExpression(PBinaryExpr e) {
        enterExpression(e);
    }
    
    public void leaveBinaryExpression(PBinaryExpr e) { }
    public void enterUnaryExpression(PUnaryExpr e) {
        enterExpression(e);
    }
    
    public void leaveUnaryExpression(PUnaryExpr e) { }
    
    public void enterCastExpression(PCastExpression e) {
        enterExpression(e);
    }
    
    public void leaveCastExpression(PCastExpression e) { }
    
    public void visitLiteral(PLiteral l) {
        enterExpression(l);
    }
    
    public void visitVariableAccess(PVariableAccessExpr l) {
        enterExpression(l);
    }

    public void enterMethodInvocation(PMethodInvocation m) {
        enterExpression(m);
    }

    public void leaveMethodInvocation(PMethodInvocation m) { }

    public void enterInstanceCreation(PInstanceCreation a) { 
        enterExpression(a);
    }
    
    public void leaveInstanceCreation(PInstanceCreation m) { }


    public void enterArrayCreation(PArrayCreation a) { 
        enterExpression(a);
    }
    
    public void leaveArrayCreation(PArrayCreation m) { }

    public void enterArrayAccess(PArrayAccess a) { 
        enterExpression(a);
    }
    
    public void enterReturn(PReturn r) {
        visitStatement(r);
    }
    
    public void leaveReturn(PReturn r) { }
    
    public void leaveArrayAccess(PArrayAccess m) { }

    public void enterExpression(PExpression e) { }
    
}
