package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/**
  * @author Pekka Uronen
  *
  * created         31.9.1999
  */
public class NonexistentConstructorException extends SemanticException {
    
    PInstanceCreation insCre;
    
    public NonexistentConstructorException(Type[] argt) {
    
    }
    
    public void setInstanceCreation(PInstanceCreation insCre) {
        this.insCre = insCre;
    }
    
    public String toString() {
         
         Type t = insCre.getType();
         String typeStr = t.toString();
        
         return (
            "<HTML><HEAD><TITLE>XXX</TITLE></HEAD>\n" +
            "<BODY bgcolor=white>" +
            "<H1>There is NO such constructor.</H3>\n" +
            "<P>" +
            "Your program tries to invoke a nonexisting " +
            "constructor in class <B>" + typeStr + "</B>. " +
            "This means that your program can not be compiled." +
            "Go fix it." +
            "</BODY></HTML>"
            );
    }
    
}