package jeliot.parser.error;

import java.util.*;
import jeliot.lang.*;
import jeliot.parser.*;

/**
  * @author Pekka Uronen
  *
  * created         27.9.1999
  */
public class NonexistentMethodException extends SemanticException {
    
    PMethodInvocation invo;
    
    public NonexistentMethodException(
            String methodName, Type[] argt) {
    }
    
    public void setInvocation(PMethodInvocation invo) {
        this.invo = invo;
    }
    
    public String toString() {
         
         Type t = invo.getTargetType();
         String typeStr = t.toString();
         String methName = invo.getIdentifier();
        
         return (
            "<HTML><HEAD><TITLE>XXX</TITLE></HEAD>\n" +
            "<BODY bgcolor=white>" +
            "<H1>There is NO such method.</H3>\n" +
            "<P>" +
            "Your program tries to invoke method <B>" +
            methName + "</B> in class <B>" + typeStr + "</B>." +
            "There is, however, no such method in class <B>" +
            typeStr + "</B>." + 
            "This means that your program can not be compiled." +
            "Go fix it." +
            "</BODY></HTML>"
            );
    }
    
}